commit 0490cb0e6113783173f1b986211267fd03415346
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Tue Apr 7 14:30:53 2020 +0200

    openmp: Fix parallel master error recovery [PR94512]
    
    We need to set OMP_PARALLEL_COMBINED only if the parsing of omp_master
    succeeded, because otherwise there is no nested master construct in the
    parallel.
    
    2020-04-07  Jakub Jelinek  <jakub@redhat.com>
    
            PR c++/94512
            * c-parser.c (c_parser_omp_parallel): Set OMP_PARALLEL_COMBINED
            if c_parser_omp_master succeeded.
    
            * parser.c (cp_parser_omp_parallel): Set OMP_PARALLEL_COMBINED
            if cp_parser_omp_master succeeded.
    
            * g++.dg/gomp/pr94512.C: New test.

diff --git a/gcc/c/ChangeLog b/gcc/c/ChangeLog
index 1bfcefb875b..3439f6d4e65 100644
--- a/gcc/c/ChangeLog
+++ b/gcc/c/ChangeLog
@@ -1,5 +1,9 @@
 2020-04-07  Jakub Jelinek  <jakub@redhat.com>
 
+	PR c++/94512
+	* c-parser.c (c_parser_omp_parallel): Set OMP_PARALLEL_COMBINED
+	if c_parser_omp_master succeeded.
+
 	Backported from mainline
 	2020-03-23  Jakub Jelinek  <jakub@redhat.com>
 
diff --git a/gcc/cp/ChangeLog b/gcc/cp/ChangeLog
index ae33956b867..cb49aeccafa 100644
--- a/gcc/cp/ChangeLog
+++ b/gcc/cp/ChangeLog
@@ -1,5 +1,9 @@
 2020-04-07  Jakub Jelinek  <jakub@redhat.com>
 
+	PR c++/94512
+	* parser.c (cp_parser_omp_parallel): Set OMP_PARALLEL_COMBINED
+	if cp_parser_omp_master succeeded.
+
 	Backported from mainline
 	2020-04-04  Jakub Jelinek  <jakub@redhat.com>
 
diff --git a/gcc/testsuite/ChangeLog b/gcc/testsuite/ChangeLog
index 660def73d7f..7aed8e289c1 100644
--- a/gcc/testsuite/ChangeLog
+++ b/gcc/testsuite/ChangeLog
@@ -1,5 +1,8 @@
 2020-04-07  Jakub Jelinek  <jakub@redhat.com>
 
+	PR c++/94512
+	* g++.dg/gomp/pr94512.C: New test.
+
 	PR target/94488
 	* gcc.c-torture/compile/pr94488.c: New test.
 
diff --git a/gcc/testsuite/g++.dg/gomp/pr94512.C b/gcc/testsuite/g++.dg/gomp/pr94512.C
new file mode 100644
index 00000000000..8ba0e65795f
--- /dev/null
+++ b/gcc/testsuite/g++.dg/gomp/pr94512.C
@@ -0,0 +1,18 @@
+// PR c++/94512
+
+void
+foo ();
+
+template <int>
+void
+bar ()
+{
+#pragma omp parallel master taskloop
+  foo ();	// { dg-error "for statement expected before" }
+}
+
+void
+baz ()
+{
+  bar<0> ();
+}

